<'
# Copyright (c) 2012-2013,2017 LAAS/CNRS
# All rights reserved.
#
# Redistribution and use  in source  and binary  forms,  with or without
# modification, are permitted provided that the following conditions are
# met:
#
#   1. Redistributions of  source  code must retain the  above copyright
#      notice and this list of conditions.
#   2. Redistributions in binary form must reproduce the above copyright
#      notice and  this list of  conditions in the  documentation and/or
#      other materials provided with the distribution.
#
#                                      Anthony Mallet on Mon Sep 17 2012
#

if {[llength $argv] != 1} { error "expected arguments: component" }
lassign $argv component

# compute handy shortcuts
set comp [$component name]
set COMP [string toupper [$component name]]

lang c
'>
#ifndef H_<"$COMP">_MSGLIB
#define H_<"$COMP">_MSGLIB

#include "actionlib/client/action_client.h"

#include "<"$comp">_service.h"
#include "<"$comp">_action.h"
#include "<"$comp">_portlib.h"

<'foreach s [$component services] {'>
<'  if {[catch {$s task}]} {'>
<'  } else {'>
typedef actionlib::ActionClient< genom::action_<"[$s name]"> >
	gnmix_<"[$s name]">;
<'  }'>
<'}'>

template<typename T> struct gnmix_topic_connection {
  ros::Subscriber s;
  boost::shared_ptr<T const> data;
  time_t sent;
  pthread_spinlock_t cblock;

  gnmix_topic_connection():sent(0) {
    pthread_spin_init(&cblock, 0);
  };

  ~gnmix_topic_connection() {
    pthread_spin_destroy(&cblock);
  };
};

struct connections {
<'foreach s [$component services] {'>
<'  if {[catch {$s task}]} {'>
  ros::ServiceClient <"[$s name]">_;
<'  } else {'>
  gnmix_<"[$s name]"> *<"[$s name]">_;
<'  }'>
<'}'>

<'foreach p [$component ports out simple] {'>
  gnmix_topic_connection< genom::port_<"[$p name]"> > <"[$p name]">_;
<'}'>
<'foreach p [$component ports out multiple] {'>
  std::map <std::string,
    gnmix_topic_connection< genom::port_<"[$p name]"> > > <"[$p name]">_;
<'}'>

  connections() {
<'foreach s [$component services] {'>
<'  if {![catch {$s task}]} {'>
  <"[$s name]">_ = NULL;
<'  }'>
<'}'>
  }
};

genom_event	genom_<"$comp">_decodex(const char *json, void *&exdetail,
                        void (*&exfini)(void *));

#endif /* H_<"$COMP">_MSGLIB */
